/*****************************************************************************\

    Filename :           CLRGLOB.PRG
    Version / Date :     3.0 / 10.1990

    Language :           CLIPPER 5.0

    Purpose :            CLREPORT - global definitions

    Author / (C) :	 Huggle / Dr. Huggle & Partner GmbH

\*****************************************************************************/

#include "clrepgen.ch"


**********< Page format >******************************************************

function ClrGlobPage (aData)

#ifdef GERMAN
  static cHead  := "Seitenformatierung", ;
	 cQuery := "Auch in Konfigurationsdatei abspeichern"
  static aSay := { "Seitenlnge.......:", "Seitenbreite......:", ;
		   "Linker Rand.......:", "Rechter Rand......:", ;
		   "Kopfzone..........:", "Fuzone...........:", ;
		   "Anzahl Kopien.....:", "Erste Seitennummer:", ;
		   "Letzte Seitennr...:",                    [], ;
		   "Eject vor Druck...:", "Eject nach Druck..:", ;
		   "Seitenvorschub....:", "Letzte S. fllen..:", ;
		   "Info berschreiben:" }
#else
  static cHead  := "Page Format", ;
	 cQuery := "Overwrite default values too"
  static aSay := { "Page length.......:", "Page width........:", ;
		   "Left margin.......:", "Right margin......:", ;
		   "Head zone.........:", "Foot zone.........:", ;
		   "No. of copies.....:", "First page........:", ;
		   "Last page.........:",                    [], ;
		   "Eject before print:", "Eject after print.:", ;
		   "Advance page......:", "Fill last page....:", ;
		   "Overwrite info....:" }
#endif
  static aCoord := { {  1,  2 }, {  1, 41 }, {  2,  2 }, {  2, 41 }, ;
		     {  3,  2 }, {  3, 41 }, {  5,  2 }, {  7,  2 }, ;
		     {  7, 41 }, {  0,  0 }, {  9,  2 }, { 10,  2 }, ;
		     { 11,  2 }, { 12,  2 }, { 13,  2 } }
  static aPic := { "999" , "999", "999", "999", "999", "999", "999", ;
		   "999", "9999", NIL, NIL, NIL, NIL, NIL, NIL }
  static aWhen := { .t., .t., .t., .t., .t., .t., .t., .t., .t., .f., ;
		    .t., .t., .t., .t., .t. }
  local aValid := { {|xValue| xValue >= 0 }, {|xValue| xValue > 0 }, ;
		    {|xValue, g, aInput, n| ;
			0 <= xValue .and. xValue < aInput[2] }, ;
		    {|xValue, g, aInput, n| ;
			0 <= xValue .and. xValue < aInput[2] }, ;
		    {|xValue, g, aInput, n| ;
			aInput[1] == 0 .or. ;
			(0 <= xValue .and. xValue < aInput[1]) }, ;
		    {|xValue, g, aInput, n| ;
			aInput[1] == 0 .or. ;
			(0 <= xValue .and. xValue < aInput[1]) }, ;
		    {|xValue| xValue >= 0 }, {|xValue| xValue > 0 }, ;
		    {|xValue, g, aInput, n| xValue >= aInput[n - 1] .or. ;
					    xValue == 0 }, ;
		    NIL, NIL, NIL, NIL, NIL, NIL }
  local aFlags := { {  4, 0, replicate ("", 72) }, ;
		    {  6, 0, replicate ("", 72) }, ;
		    {  8, 0, replicate ("", 72) } }
  local lConfig, lStored, aGets

  private V_HSTW := "GLOB PAGE"

  if ( lConfig := aData == NIL )		/* get CLREPORT.RPG */
    aData := RPGReadWrite (NIL) ; end

  /* prepare data */

  /* read data */
  lStored := ClrMask ({ 4, 3, 20, 76 }, .f., /* color */, cHead, /* foot */, ;
                      aFlags, aData, /* name */, aWhen, aCoord, aSay, ;
                      aPic, aValid, /* list */)

  /* pack data */

  if ( lStored )				/* store CLREPORT.RPG */
    if ( iif (lConfig, .t., ;
              ClrYNQuery (NIL, NIL, .t., /* color */, cQuery, .f.)) )
      RPGReadWrite (aData) ; end
  end

  ClrWindow ()					/* mask window */

return NIL


**********< Supplements >******************************************************

function ClrGlobGlob (aData)

#ifdef GERMAN
  static cHead  := "Zustze", ;
	 cQuery := "Auch in Konfigurationsdatei abspeichern"
  static aSay := { "Ausgabegert................:", ;
		   "Suchpfad Voreinstellung.....:", ;
		   "Suchpfad fr DBF............:", ;
		   "Pfad fr Temporr-Dateien...:", ;
		   "Druckerdatei................:", ;
		   "Drucker-Nr..................:", ;
		   "NLQ-Druck...................:", ;
		   "Pause bei Seitenwechsel.....:" }
#else
  static cHead  := "Supplement", ;
	 cQuery := "Overwrite default values too"
  static aSay := { "Printing device.............:", ;
		   "Default search path.........:", ;
		   "Search path for DBF.........:", ;
		   "Search path for tempfiles...:", ;
		   "Printer file................:", ;
		   "Printer number..............:", ;
		   "NLQ-mode....................:", ;
		   "Pause change page...........:" }
#endif
  static aCoord := { {  1, 2 }, {  3, 2 }, {  5, 2 }, {  7, 2 }, ;
		     {  9, 2 }, { 11, 2 }, { 13, 2 }, { 15, 2 } }
  static aPic := { "@S30!", "@S30!", "@S30!", "@S30!", "@S30!", ;
		   "999", NIL, NIL }
  local aValid := { NIL, NIL, NIL, NIL, NIL, {|xValue| xValue >= 0 }, ;
		    NIL, NIL }
  local lConfig, lStored, i := 0

  private V_HSTW := "GLOB ADD"

  if ( lConfig := aData == NIL )		/* get CLREPORT.RAD */
    aData := RADReadWrite (NIL) ; end

  /* prepare data */
  aData[1] := ClrStrRPad (aData[1], 62)		/* destination device */
  aData[2] := ClrStrRPad (aData[2], 62)		/* Default path */
  aData[3] := ClrStrRPad (aData[3], 62)		/* path for DBF */
  aData[4] := ClrStrRPad (aData[4], 62)		/* path for temporary files */
  aData[5] := ClrStrRPad (aData[5], 62)		/* printer file */

  /* read data */
  lStored := ClrMask ({ 3, 9, 21, 74 }, .f., /* color */, cHead, /* foot */, ;
                      /* flags */, aData, /* name */, /* when */, aCoord, ;
		      aSay, aPic, aValid, /* list */)

  /* pack data */
  AEval (aData, {|| ++i, aData[i] := Trim (aData[i]) }, 1, 5)

  if ( lStored )				/* store CLREPORT.RAD */
    if ( iif (lConfig, .t., ;
              ClrYNQuery (NIL, NIL, .t., /* color */, cQuery, .f.)) )
      RADReadWrite (aData) ; end
  end

  ClrWindow ()					/* mask window */

return NIL


**********< Get/set defaults from/to CLREPORT.RPG >****************************

static func RPGReadWrite (aData)

#ifdef GERMAN
  static cMess1 := "Seitenformatdatei hat altes Format; ignoriert", ;
	 cMess2 := "Format-Datei CLREPORT.RPG nicht gefunden"
#else
  static cMess1 := "Old page format file; ignored", ;
	 cMess2 := "Format-file CLREPORT.RPG not found"
#endif
  local i := 0

  private P_1, P_2, P_3, P_4, P_5, P_6, P_7, P_8, P_9, P_10, P_11, ;
	  P_12, P_13, P_14, P_15

  if ( aData == NIL )			/* read */
    if ( File ("clreport.rpg") )
      restore from clreport.rpg additive

      if ( ValType (m->P_15) == "C" )
        ClrMessage (cMess1, 1)		/* old CLREPORT */
      else
        aData := { m->P_1, m->P_2, m->P_3, m->P_4, m->P_5, m->P_6, ;
		   m->P_7, m->P_8, m->P_9, m->P_10, m->P_11, m->P_12, ;
		   m->P_13, m->P_14, m->P_15 }
      end
    else
      ClrMessage (cMess2, 1) ; end

    if ( aData == NIL )			/* set defaults */
      aData := { 66, 65, 4, 4, 2, 2, 1, 1, 999, 0, .f., .f., .t., .t., .f. }
    end
  else					/* write */
    AEval (aData, {|xData| &("P_" + Ltrim (str (++i))) := xData })
    save to clreport.rpg all like P_*
  end

return aData


**********< Get/set defaults from/to CLREPORT.RAD >****************************

static func RADReadWrite (aData)

#ifdef GERMAN
  static cMess1 := "Zustze-Datei hat altes Format; ignoriert", ;
	 cMess2 := "Zustze-Datei CLREPORT.RAD nicht gefunden"
#else
  static cMess1 := "Old supplement data file; ignored", ;
	 cMess2 := "Supplement-file CLREPORT.RAD not found"
#endif
  local i := 0

  private P_1, P_2, P_3, P_4, P_5, P_6, P_7, P_8

  if ( aData == NIL )			/* read */
    if ( File ("clreport.rad") )
      restore from clreport.rad additive

      if ( ValType (m->P_8) == "C" )
        ClrMessage (cMess1, 1)		/* old CLREPORT */
      else
        aData := { m->P_1, m->P_2, m->P_3, m->P_4, ;
		   m->P_5, m->P_6, m->P_7, m->P_8 }
      end
    else
      ClrMessage (cMess2, 1) ; end

    if ( aData == NIL )			/* set defaults */
      aData := { "PRN", [], [], [], [], 0, .f., .f. } ; end
  else					/* write */
    AEval (aData, {|xData| &("P_" + Ltrim (str (++i))) := xData })
    save to clreport.rad all like P_*
  end

return aData


**********< Printer installation >*********************************************

function ClrGlobPrn ()

#ifdef GERMAN
  static cHead1  := "Eingabe: Pfad und Name der Druckerdatei > F10 Liste", ;
	 cQuery1 := "Datei nicht vorhanden. Neu anlegen", ;
	 cMess1  := "Alte Index-Datei; bei Gelegenheit lschen", ;
	 cMess2  := "Fehlender Index/falscher Schlssel; Reindizierung", ;
	 cMess3  := "Reorganisiere Druckerdatei", ;
	 cSay    := "Druckernummer:", ;
	 cHead2  := "Drucker Installation", ;
	 cFoot2  := " <ins>, <del>, <ret>, <esc>, Anfangsbuchstabe Name ", ;
	 cQuery2 := "Drucker-Datei reorganisieren"
#else
  static cHead1  := "Input: Path and Filename > F10 Selection", ;
	 cQuery1 := "File does not exist. Create", ;
	 cMess1  := "Old index file; can be deleted", ;
	 cMess2  := "Missing index / incorrect index key; reindexing", ;
	 cMess3  := "Reorganizing printer file", ;
	 cSay    := "Printer Number", ;
	 cHead2  := "Printer Installation", ;
	 cFoot2  := " <ins>, <del>, <ret>, <esc>, first letter of name ", ;
	 cQuery2 := "Reorganize printer database"
#endif
  local cFile, cBasename, cNT1, cNT2, lEdit, nPrno := 0, aFlags, lDone := .f.

  field PR_NO, PR_NAME

  private V_HSTW := "GLOB PRINT"

  repeat
    cFile := ClrStrRPad ("CLREPORT.RPR", 62) ; lEdit := .f.

    if ( ClrAccept (4, 12, .f., /* color */, cHead1, [], @cFile, "@S55K!", ;
		    {|xValue| ! Empty (xValue) .and. ! '*' $ xValue .and. ;
			      ! '?' $ xValue .and. ! ' ' $ Trim (xValue) }, ;
		    [printFile], {|xValue,g,aInput,n| PrinterList (xValue)}) )
      if ( ! ('.' $ ClrPathExp (cFile := AllTrim (cFile), 2)) )
        cFile += ".RPR" ; end

      if ( ! File (cFile) )
        if ( ClrYNQuery (7, 18, .t., /* color */, cQuery1, .f.) )
          lDone := lEdit := PrnDbfCreate (cFile)
        end
      elseif ( ! OpenDbf (cFile, "PRINTER") )
        ClrNetErr ()
      else
        if ( File ((cBasename := ClrPathExp (cFile, 4)) + ".NTX") )
          ClrMessage (cMess1, 2) ; end

        if ( File (cBasename + ".NT1") .and. File (cBasename + ".NT2") )
          PRINTER->(SetIndex (cBasename + ".NT1", cBasename + ".NT2"))
        end

        if ( Upper (PRINTER->(IndexKey (1))) != "STR(PR_NO,4)" .or. ;
             Upper (PRINTER->(IndexKey (2))) != "UPPER(PR_NAME)" )
          ClrMessage (cMess2, 3)

          if ( ! PRINTER->(OpenDbf (cFile, "PRINTER", .f., .t.)) )
            ClrNetErr ()
          else
            PRINTER->(IndexOn (  STR(PR_NO,4), cNT1 := cBasename + ".NT1"))
            PRINTER->(IndexOn (UPPER(PR_NAME), cNT2 := cBasename + ".NT2"))
            PRINTER->(OpenDbf (cFile, "PRINTER", .f., .f., cNT1, cNT2))
          end

          ClrWindow ()		/* wait message */
        end

        lDone := lEdit := Select ("PRINTER") != 0
      end
    else
      lDone := .t. ; end

    if ( iif (lEdit, ClrAccept (7, 18, .t., CLRCOLOR[_C_QUERY], /* head */, ;
			        cSay, @nPrno, "999"), .f.) )
      aFlags := { .f., .t., .t., .f., ;
                  PRINTER->(iif (nPrno != 0 .and. Seek (Str (nPrno, 4), .t.), ;
				 Recno (), NIL)), ;
		  NIL }

      PRINTER->(SetOrder (2))
      ClrSelection ({ 7, 18, 21, NIL }, .t., /* color */, cHead2, cFoot2, ;
		    aFlags, "PRINTER", " Nr.     Name", ;
		    {|| Str (PR_NO, 4) + "    " + Left (PR_NAME, 40) }, ;
		    {|nKey, n, nRow, cSel| PrinterCallback (nKey) })
      PRINTER->(SetOrder (1))

      if ( PRINTER->(OpenDbf (cFile, "PRINTER", .f., .t.)) )
        if ( ClrYNQuery (7, 18, .t., /* color */, cQuery2) )
          ClrMessage (cMess3, 3)

          PRINTER->(Pack ())
          PRINTER->(IndexOn (  STR(PR_NO,4), ClrPathExp (cFile, 4) + ".NT1"))
          PRINTER->(IndexOn (UPPER(PR_NAME), ClrPathExp (cFile, 4) + ".NT2"))

          ClrWindow ()
        end
      end
    end

    ClrWindow ()		/* accept window */
  until ( lDone )

  CloseDbf ("PRINTER")

return NIL


**********< UDF for printer BROWSE >*******************************************

static func PrinterCallback (nKey)

#ifdef GERMAN
  local bQuery  := { |cName| "Alle Daten zu " + cName + " lschen" }, ;
	aPrompt := { "Abbrechen", "Lschen" }
#else
  local bQuery  := { |cName| "Delete all data for " + cName }, ;
	aPrompt := { "Abort", "Continue" }
#endif
  local nRecno := PRINTER->(Recno ()), lResult := .f., nNumber
  Local aFields

  do case
    case nKey == 0
      /* idel state */
    case nKey == K_ENTER
      if ( PRINTER->(RLock ()) )
        lResult := PrinterMask () ; PRINTER->(Unlock ())
      else ; ClrNetErr () ; end
    case nKey == K_INS
      aFields := Rec2Array()
      PRINTER->(SetOrder (1), GoBottom (), nNumber := FIELD->pr_no, ;
		SetOrder (2))
      if ( PRINTER->(Append (NIL, {|| FIELD->pr_no := nNumber + 1 })) )
        Array2Rec( aFields )
	PRINTER->pr_no := nNumber + 1
	if ( ! (lResult := PrinterMask ()) )
          PRINTER->(Del (.t.)) ; PRINTER->(Go (nRecno)) ; end

        PRINTER->(Unlock ())
      else ; ClrNetErr () ; end
    case nKey == K_DEL
      if ( lResult := ClrQuery (NIL, NIL, .t., NIL, ;
		Eval (bQuery, AllTrim (PRINTER->pr_name)), aPrompt) == 2 )
        if ( ! (lResult := PRINTER->(Del ())) )
          ClrNetErr () ; end
      end
    case nKey <= 255
      if ( ! (lResult := PRINTER->(Seek (upper (chr (nKey)), .t.))) )
        PRINTER->(Go (nRecno)) ; end
  end

return lResult


**********< Printer mask >*****************************************************

static func PrinterMask ()

#ifdef GERMAN
  static cHead := "Drucker-Sequenzen"
  static aSay := { "Nummer...:", "Name.....:", "Init.....:", "Exit.....:", ;
		   "Fett an..:", "Fett aus.:", "Unt. ein.:", "Unt. aus.:", ;
		   "Breit an.:", "Breit aus:", "Kurs. an.:", "Kurs. aus:", ;
		   "Hoch. an.:", "Hoch. aus:", "Tief. an.:", "Tief. aus:", ;
		   "Eng an...:", "Eng aus..:", "NLQ......:", "Standard.:", ;
		   "Aux 1 an.:", "Aux 1 aus:", "Aux 2 an.:", "Aux 2 aus:", ;
		   "Aux 3 an.:", "Aux 3 aus:", "Aux 4 an.:", "Aux 4 aus:", ;
		   "Aux 5 an.:", "Aux 5 aus:", "Aux 6 an.:", "Aux 6 aus:", ;
		   "Aux 7 an.:", "Aux 7 aus:", ;
		   "Graphiktreiber:", "Seitenlnge, Kopf-/Fuzone..:", ;
		   "-", "-" }
#else
  static cHead := "Printer-Sequences"
  static aSay := { "Number...:", "Name.....:", "Init.....:", "Exit.....:", ;
		   "Bold on..:", "Bold off.:", "Undl. on.:", "Undl. off:", ;
		   "Enlrg.on.:", "Enlrg.off:", "Ital. on.:", "Ital. off:", ;
		   "Sups. on.:", "Sups. off:", "Subs. on.:", "Subs. off:", ;
		   "Cond. on.:", "Cond. off:", "NLQ......:", "Draft....:", ;
		   "Aux 1 on.:", "Aux 1 off:", "Aux 2 on.:", "Aux 2 off:", ;
		   "Aux 3 on.:", "Aux 3 off:", "Aux 4 on.:", "Aux 4 off:", ;
		   "Aux 5 on.:", "Aux 5 off:", "Aux 6 on.:", "Aux 6 off:", ;
		   "Aux 7 on.:", "Aux 7 off:", ;
		   "Graphicsdriver:", "Page length, head-/foot marg:", ;
		   "-", "-" }
#endif
  static aName := { "pr_no", "pr_name", "init_pr", "exit_pr", ;
		    "bold_on", "bold_off", "undl_on", "undl_off", ;
		    "enl_on", "enl_off", "ital_on", "ital_off", ;
		    "high_on", "high_off", "low_on", "low_off", ;
		    "cond_on", "cond_off", "nlq_on", "nlq_off", ;
		    "user1_on", "user1_off", "user2_on", "user2_off", ;
		    "user3_on", "user3_off", "user4_on", "user4_off", ;
		    "user5_on", "user5_off", "user6_on", "user6_off", ;
		    "user7_on", "user7_off", ;
		    "graph_driv", "page_len", "head_marg", "foot_marg" }
  static aCoord := { {  1,  2 }, {  1, 40 }, {  3,  2 }, {  3, 40 }, ;
		     {  4,  2 }, {  4, 40 }, {  5,  2 }, {  5, 40 }, ;
		     {  6,  2 }, {  6, 40 }, {  7,  2 }, {  7, 40 }, ;
		     {  8,  2 }, {  8, 40 }, {  9,  2 }, {  9, 40 }, ;
		     { 10,  2 }, { 10, 40 }, { 11,  2 }, { 11, 40 }, ;
		     { 12,  2 }, { 12, 40 }, { 13,  2 }, { 13, 40 }, ;
		     { 14,  2 }, { 14, 40 }, { 15,  2 }, { 15, 40 }, ;
		     { 16,  2 }, { 16, 40 }, { 17,  2 }, { 17, 40 }, ;
		     { 18,  2 }, { 18, 40 }, ;
		     { 20,  2 }, { 20, 33 }, { 20, 67 }, { 20, 72 } }
  static aPic := { [], "@S25", "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", ;
		   "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", ;
		   "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", ;
		   "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", ;
		   "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", "@S25#", ;
		   "@S25#", "@S25#", "@S25#", "@S13!", "999", "99", "99" }
  local aFlags := { {  2, 0, Replicate ("", 78) }, ;
		    { 19, 0, Replicate ("", 78) } }

return ClrMask ({ 1, 0, 23, 79 }, .t., /* color */, cHead, /* foot */, ;
		aFlags, "PRINTER", aName, /* when */, aCoord, aSay, aPic)


**********< Create printer file structure >************************************

static func PrnDbfCreate (cFilename)

  static aStructure := { ;
	{ "PR_NO",      "N",  3, 0 }, { "PR_NAME",    "C", 50, 0 }, ;
	{ "INIT_PR",    "C", 50, 0 }, { "EXIT_PR",    "C", 50, 0 }, ;
	{ "BOLD_ON",    "C", 50, 0 }, { "BOLD_OFF",   "C", 50, 0 }, ;
	{ "UNDL_ON",    "C", 50, 0 }, { "UNDL_OFF",   "C", 50, 0 }, ;
	{ "ENL_ON",     "C", 50, 0 }, { "ENL_OFF",    "C", 50, 0 }, ;
	{ "ITAL_ON",    "C", 50, 0 }, { "ITAL_OFF",   "C", 50, 0 }, ;
	{ "HIGH_ON",    "C", 50, 0 }, { "HIGH_OFF",   "C", 50, 0 }, ;
	{ "LOW_ON",     "C", 50, 0 }, { "LOW_OFF",    "C", 50, 0 }, ;
	{ "COND_ON",    "C", 50, 0 }, { "COND_OFF",   "C", 50, 0 }, ;
	{ "NLQ_ON",     "C", 50, 0 }, { "NLQ_OFF",    "C", 50, 0 }, ;
	{ "USER1_ON",   "C", 50, 0 }, { "USER1_OFF",  "C", 50, 0 }, ;
	{ "USER2_ON",   "C", 50, 0 }, { "USER2_OFF",  "C", 50, 0 }, ;
	{ "USER3_ON",   "C", 50, 0 }, { "USER3_OFF",  "C", 50, 0 }, ;
	{ "USER4_ON",   "C", 50, 0 }, { "USER4_OFF",  "C", 50, 0 }, ;
	{ "USER5_ON",   "C", 50, 0 }, { "USER5_OFF",  "C", 50, 0 }, ;
	{ "USER6_ON",   "C", 50, 0 }, { "USER6_OFF",  "C", 50, 0 }, ;
	{ "USER7_ON",   "C", 50, 0 }, { "USER7_OFF",  "C", 50, 0 }, ;
	{ "RESERV_ON",  "C", 50, 0 }, { "RESERV_OFF", "C", 50, 0 }, ;
	{ "GRAPH_DRIV", "C", 20, 0 }, { "PAGE_LEN",   "N",  3, 0 }, ;
	{ "HEAD_MARG",  "N",  2, 0 }, { "FOOT_MARG",  "N",  2, 0 } }
  local cBasename := ClrPathExp (cFilename, 4), lResult, cNT1, cNT2

  field PR_NO, PR_NAME

  DBCreate (cFilename, aStructure)

  if ( ! (lResult := OpenDbf (cFilename, "PRINTER", .t., .t.)) )
    ClrNetErr ()
  else
    PRINTER->(IndexOn (  STR(PR_NO,4), cNT1 := cBasename + ".NT1"))
    PRINTER->(IndexOn (UPPER(PR_NAME), cNT2 := cBasename + ".NT2"))
    PRINTER->(OpenDbf (cFilename, "PRINTER", .f., .f., cNT1, cNT2))
  end

return lResult


**********< Selections F10 >***************************************************

static func PrinterList (xValue)

  local xResult

  if ( Empty (xResult := ClrSDir ("*.rpr", xValue)) )
    xResult := NIL ; end

return xResult



**********< Ergnzungen >******************************************************

Static Function Rec2Array()

	Local nMax := FCount()
	Local aRec := Array( nMax )
	Local i
	
	For i := 1 To nMax
	    aRec[ i ] := FieldGet( i )
	Next
	
	Return ( aRec )


Static Procedure Array2Rec( aRec )

	Local nMax := FCount()
	Local i
	
	For i := 1 To nMax
	    FieldPut( i, aRec[ i ] )
	Next
	
	Return


*******************************************************************************
*******************************************************************************
* EOF CLRGLOB.PRG