/*****************************************************************************\

    Filename :			CLRPRINT.PRG / CLREPORT.PRG
    Version / Date :		3.0 / 11.1990

    Purpose :			Print Report

    Author / (C) :		Huggle / Dr. Huggle & Partner GmbH

\*****************************************************************************/

#include "clrepgen.ch"
#include "clreport.ch"


function ClrRepoExec (cRepo)

#ifdef GERMAN
  static cHead    := "Ausgabegert", ;
	 cSay	  := "Dateiname:", ;
	 aDestDev := { " paralleler Drucker 1 ", ;
		       " paralleler Drucker 2 ", ;
		       " paralleler Drucker 3 ", ;
		       " serieller Drucker 1  ", ;
		       " serieller Drucker 2  ", ;
		       " Bildschirmausgabe 1  ", ;
		       " Bildschirmausgabe 2  ", ;
		       " Datei                " }
#else
  static cHead    := "Device", ;
	 cSay     := "File name:", ;
	 aDestDev := { " parallel printer 1 ", ;
		       " parallel printer 2 ", ;
		       " parallel printer 3 ", ;
		       " serial printer 1   ", ;
		       " serial printer 2   ", ;
		       " Screen output 1    ", ;
		       " Screen output 2    ", ;
		       " File               " }
#endif
  static aDevices := { "lpt1", "lpt2", "lpt3", "com1", "com2", [], [], NIL }
  local aDoMore := { { |cDest| PrinterOpt (cRepo, cDest) }, ;
		     { |cDest| PrinterOpt (cRepo, cDest) }, ;
		     { |cDest| PrinterOpt (cRepo, cDest) }, ;
		     { |cDest| PrinterOpt (cRepo, cDest) }, ;
		     { |cDest| PrinterOpt (cRepo, cDest) }, ;
		     { |cDest| Screen1Opt (cRepo, cDest) }, ;
		     { |cDest| Screen2Opt (cRepo, cDest) }, ;
		     { |cDest| PrinterOpt (cRepo, cDest) } }
  local nDest, cDevice, lExec := .f.

  private V_HSTW := "OUT REPO"

  if ( (nDest := ClrAchoice ({ 6, 18, NIL, NIL }, .f., CLRCOLOR[_C_EXTRA], ;
			     cHead, /* foot */, /* flags */, aDestDev)) != 0 )
    if ( iif ((cDevice := aDevices[nDest]) != NIL, .t., ;
	      (cDevice := Space (80), ;
	       ClrAccept (8, 26, .t., /* color */,/* head */, cSay, @cDevice,;
			  "@S30!", {|cValue| ! Empty (cValue)}))) )
      lExec := Eval (aDoMore[nDest], Trim (cDevice))
    end
  end

  ClrWindow ()		/* achoice window */

return lExec


**********< Get additional options >*******************************************

static func PrinterOpt (cRepo, cDest)		/* printer options */

#ifdef GERMAN
  static cHead := "Ausgabeoptionen", ;
	 aSay  := { "NLQ..............: ", "Pause............: ", ;
		    "Kopien...........: ", ;
		    "erste Seite......: ", "letzte Seite.....: " }
#else
  static cHead := "Output Options", ;
	 aSay  := { "NLQ..............: ", "Pause............: ", ;
		    "Copies...........: ", ;
		    "First Page.......: ", "Last Page........: " }
#endif
  static aCoord := { { 1, 2 }, { 2, 2 }, { 4, 2 }, { 6, 2 }, { 7, 2 } }
  static aPic := { NIL, NIL, "99", "9999", "9999" }
  local aGet := { .f., .f., 1, 1, 9999 }
  local bValid := { |xValue| xValue > 0 }
  local aValid := { NIL, NIL, bValid, bValid, bValid }

  local lExec := .f., aUDFs, aPage, aFlag, nPrinter

  if ( ClrMask ({ 8, 26, 18, 63 }, .f., /* color */, cHead, /* foot */, ;
		/* flags */, aGet, /* name */, /* when */, aCoord, aSay, ;
		aPic, aValid) )
    aUDFs := { NIL, NIL, NIL, "Clr_PgePse", NIL, "Clr_Status", "Clr_PrnErr" }
    aPage := { NIL, NIL, NIL, NIL, NIL, NIL, ;
	       iif (aGet[3] == 1, 0, aGet[3]), aGet[4], aGet[5] }
    aFlag := { NIL, NIL, aGet[1], aGet[2], NIL, NIL }

    if ( lExec := (nPrinter := ChoosePrinter ()) != NIL )
       ReportRun (cRepo, cDest, nPrinter, aFlag, aPage, aUDFs) ; end
  end

  ClrWindow ()		/* mask window */

return lExec


static func Screen1Opt (cRepo, cDest)		/* screen output version 1 */

#ifdef GERMAN
  static cQuery  := "Im 'Bandwurm'", ;
	 aPrompt := { " Seitenweise ", " Wurm " }
#else
  static cQuery  := "Continuous", ;
	 aPrompt := { " Normal ", " Tapeworm " }
#endif
  local lExec, nChoice, aUDFs, aPage, aFlag

  if ( lExec := (nChoice := ClrQuery (8, 26, .t., /* color */, cQuery, ;
				      aPrompt, 1)) != 0 )
    aUDFs := { NIL, NIL, NIL, "Clr_PgePse", ;
	       iif (nChoice == 2, "Clr_Cancel", NIL), ;
	       "Clr_Status", "Clr_PrnErr" }
    aPage := { iif (nChoice == 2, 0, MaxRow () - 5), 0, 0, 0, 0, 0, 0, 0, 0 }
    aFlag := { NIL, NIL, NIL, nChoice == 1, nChoice == 1, NIL }
    ReportRun (cRepo, cDest, /* printer */, aFlag, aPage, aUDFs)
  end

return lExec


static func Screen2Opt (cRepo, cDest)		/* screen output version 2 */

  local aUDFs, aPage, aFlag

  aUDFs := { NIL, NIL, NIL, "Clr_PgePse", NIL, "Clr_Status", "Clr_PrnErr" }
  aPage := { NIL, 0, 0, 0, 0, 0, 0, 0, 0 }
  aFlag := { NIL, NIL, NIL, .f., .t., .t. }
  ReportRun (cRepo, cDest, /* printer */, aFlag, aPage, aUDFs)

return .t.


**********< Choose printer >***************************************************

static funct ChoosePrinter ()

#ifdef GERMAN
  static cHead := "Drucker Auswahl", ;
	 cFoot := "Buchstaben = Suche, ^RET = kein Drucker", ;
	 cMess := "Druckerdatei CLREPORT.RPR/.NT2 fehlt"
#else
  static cHead := "Printer Selection", ;
	 cFoot := "First letter = search, ^RET = no printer", ;
	 cMess := "Printer file CLREPORT.RPR/.NT2 not found"
#endif
  static cPrinter := NIL	/* last printer selected */
  local nPrinter := 0, aFlags

  if ( !File("clreport.nt2") .and. File ("clreport.rpr") )
     OpenDbf( "clreport.rpr", "PRINTER", .T., .T. )
     IndexOn( "UPPER(PR_NAME)", "clreport.nt2" )
     Close
  end
  
  if ( File ("clreport.rpr") .and. File ("clreport.nt2") )
    if ( OpenDbf ("clreport.rpr", "PRINTER", .t., .f., "clreport.nt2") )
      if ( cPrinter != NIL .and. PRINTER->(Seek (Upper (cPrinter))) )
         aFlags := { .t., .f., .f., .t., PRINTER->(Recno ()), NIL }
      else ; aFlags := { .t., .f., .f., .t., NIL, NIL } ; end

      if ( ClrSelection ({ 10, 34, 22, NIL }, .t., /* color */, cHead, ;
		         cFoot, aFlags, "PRINTER", ;
			 /* col head */, {|| Left (FIELD->pr_name, 40) }, ;
			 {|nKey, n, nRow, xSel| SeekPrinter (nKey)}) != 0 )
        if ( LastKey () != K_CTRL_RET )
          nPrinter := PRINTER->pr_no ; cPrinter := PRINTER->pr_name ; end
      else ; nPrinter := NIL ; end

      CloseDbf ("PRINTER")
    else ; ClrNetErr () ; end
  else ; ClrMessage (cMess, 1) ; end

return nPrinter


static func SeekPrinter (nKey)

  local nRecno := PRINTER->(Recno ()), lResult := .f.

  if ( 32 < nKey .and. nKey < 255 )
    if ( ! (lResult := PRINTER->(Seek (Upper (chr (nKey)), .t.))) )
      PRINTER->(Go (nRecno)) ; end
  end

return lResult


**********< Runtime call >*****************************************************

static func ReportRun (cRepo, cDest, nPrinter, aFlag, aPage, aUDFs)

#ifdef GERMAN
  local cMess := "Ausgabe von " + cRepo + " - ESC fr Abbruch"
  static aFatalErr := { ;
	"Fataler Fehler : falscher Aufruf", ;
	"Fataler Fehler : Datei zu Report-Lib fehlt", ;
	"Fataler Fehler : Ungltige Report-Lib", ;
	"Fataler Fehler : Report nicht gefunden", ;
	"Fataler Fehler : Report ist leer", ;
	"Fataler Fehler : Keine Datei angegeben", ;
	"Fataler Fehler : Hauptdatei nicht zu ffnen", ;
	"Fataler Fehler : Druck abgebrochen", ;
	"Fataler Fehler : Drucker Fehler", ;
	"Fataler Fehler : zuwenig Speicher", ;
	"Fataler Fehler : Abbruch durch Fehler-UDF", ;
	"Fataler Fehler : Hauptdatei enthlt keinen Satz", ;
	"Fataler Fehler : Fehler bei Drucker-Spooler", ;
	"Fataler Fehler : Netzwerkfehler", ;
	"Fataler Fehler : Rekursiver Aufruf", ;
	"Fataler Fehler : Ausdrucksfehler", ;
	}
#else
  local cMess := cRepo + " will be printed - ESC to stop"
  static aFatalErr := { ;
	"Fatal error : call error", ;
	"Fatal error : report library not found", ;
	"Fatal error : invalid report library", ;
	"Fatal error : report in library not found", ;
	"Fatal error : report is empty", ;
	"Fatal error : no DBF specified", ;
	"Fatal error : unable to open main file", ;
	"Fatal error : printing terminated by user", ;
	"Fatal error : printer error", ;
	"Fatal error : out of memory", ;
	"Fatal error : output terminated via error-UDF", ;
	"Fatal error : no records in main file", ;
	"Fatal error : spooler error", ;
	"Fatal error : network error", ;
	"Fatal error : recursive call", ;
	"Fatal error : expression error", ;
	}
#endif
  local aScrWin := { 3, 4, MaxRow () - 3, MaxCol () - 4 }, nError, lError, ;
	svKeyF1

  svKeyF1 := SetKey (K_F1, NIL)

  ClrMessage (cMess, 3)

  nError := RepoExec ("LIB", cRepo, cDest, /* next */, /* for */, ;
		      /* while */, /* start */, nPrinter, /* file */, ;
		      aFlag, aPage, aUDFs, /* expr repl */, aScrWin)

  ClrWindow ()	/* message window */

  SetKey (K_F1, svKeyF1)

  if ( lError := nError < 0 .and. nError != _CLRERR_ESCAPE )
    ClrMessage (aFatalErr[-nError], 1) ; end

return lError


**********< UDSs replace internal runtime functions >**************************

function Clr_PgePse ()

#ifdef GERMAN
  static cMess := "Bitte Papier einlegen"
#else
  static cMess := "Feed paper please"
#endif

return iif (Empty (RepoDevice ()), ClrInkey (0), ClrMessage (cMess, 2)) != 0


function Clr_Cancel ()

  if ( Inkey () == 32 /* halt report by pressing space */ )
    Inkey (0) ; end

return LastKey () != K_ESC


function Clr_PrnErr (nCode, cP1, xP2)

#ifdef GERMAN
  local aMessages := { ;
	{|_1,_2| "Datei " + _1 + " (" + _2 + ") nicht gefunden"}, ;
	{|_1,_2| iif (Empty(_2), ;
		      "Temporrindex zu " + _1 + " nicht erzeugbar", ;
		      "Index " + _2 + " zu " + _1 + " nicht gefunden")}, ;
	{|_1,_2| "Relation von " + _1 + " nach " + _2 + " nicht setzbar"}, ;
	{|_1,_2| "Relationsausdruck [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "Feldausdruck [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "Indexausdruck [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "While-Bedingung [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "Startausdruck [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "Filter [" + _1 + "] zu " + _2 + " falsch"}, ;
	{|_1,_2| "Zeilenbedingung [" + _1 + "] zu Zeile " + _2 + " falsch"}, ;
	{|_1,_2| "Gruppenausdruck [" + _1 + "] zu Gruppe " + _2 + " falsch"}, ;
	}
#else
  local aMessages := { ;
	{|_1,_2| "File " + _1 + " (" + _2 + ") not found"}, ;
	{|_1,_2| iif (Empty (_2), ;
		      "Cannot create temporary index to " + _1, ;
		      "Indexfile " + _2 + " to " + _1 + " not found")}, ;
	{|_1,_2| "Relation of " + _1 + " to " + _2 + " cannot be set"}, ;
	{|_1,_2| "Relation expression [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "Field expression [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "Index expression [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "While-expression [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "Start-expression [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "Filter-condition [" + _1 + "] to " + _2 + " faulty"}, ;
	{|_1,_2| "Line- expression [" + _1 + "] line " + _2 + " faulty"}, ;
	{|_1,_2| "Group-expression [" + _1 + "] group " + _2 + " faulty"}, ;
	}
#endif

  ClrMessage (Eval (aMessages[nCode], cP1, ;
		    iif (ValType (xP2) == 'N', Ltrim (Str (xP2)), xP2)), 1)

return []


function Clr_Status (nAct, lTof, nProw, nPhrow, nPfrow, nPmrow, nPlcol, ;
		     nPmcol, nPage, nCopy, lStart, lEnd)

#ifdef GERMAN
  static cFoot := "ESC fr Abbruch", ;
	 cStr1 := "Seite :", cStr2 := "Zeile :", ;
	 cMess := "Seite wird aufbereitet"
#else
  static cFoot := "ESC to abort", ;
	 cStr1 := "Page  :", cStr2 := "Line  :", ;
	 cMess := "Preparing page"
#endif
  static lWinOpen  := .f.	/* report output window / message */
  static lMessOpen := .f.	/* message window screen output 2 */

  if ( nAct == _CLR_NEWLINE )
    if ( ! Empty (RepoDevice ()) )
      @ 17, 74 say Str (nPage, 3) ; @ 18, 74 say Str (nProw, 3) ; end
  elseif ( nAct == _CLR_START )
    if ( Empty (RepoDevice ()) )		/* screen output */
      ClrWindow (2, 2, MaxRow () - 2, MaxCol () - 2, CLRCOLOR[_C_REPOEXEC],;
		 /* head */, cFoot)
    else					/* printer */
      ClrWindow (15, 64, 20, 78, CLRCOLOR[_C_FRAME])
      @ 17, 66 say cStr1 ; @ 18, 66 say cStr2
    end

    lWinOpen := .t.
  elseif ( nAct == _CLR_END )			/* report finished */
    if ( lMessOpen ) ; ClrWindow () ; lMessOpen := .f. ; end
    if ( lWinOpen  ) ; ClrWindow () ; lWinOpen  := .f. ; end
  elseif ( RepoPaging () .and. nAct == _CLR_NEWPAGE )
    ClrMessage (cMess, 3) ; lMessOpen := .t.	/* buffered output */
  elseif ( RepoPaging () .and. nAct == _CLR_ENDPAGE )
    if ( lMessOpen ) ; ClrWindow () ; lMessOpen := .f. ; end
  end

return NIL


/*---------------------------< EOF CLRPRINT.PRG >----------------------------*/
